/*
    Project: TCTEMP
    Version: V1.5
    File   : na_filewait.c

    Copyright (c) 2006-2007 Author of TCTEMP. All rights reserved.
    Public Key Fingerprint: 75EB 6BC2 01B7 F6E7 4BD7 CC58 4A5F C393 19EE 6E69

    Covered by TrueCrypt License 2.2 the full text of which is contained
    in the file License.txt included in TCTEMP binary and source code
    distribution archives.

    The copyright notice of this source code file and the public key
    fingerprint must be retained in full.
*/

#include "na_priv.h"

BOOL NAAPI NaWaitForFile(HANDLE hFile, PLARGE_INTEGER pliTimeout)
{
    NTSTATUS      ntStatus;

#if DEBUG
    LARGE_INTEGER liTimeout;
    if (pliTimeout == NULL) {
        liTimeout.QuadPart = NA_TIMEOUT(10000);
        pliTimeout = &liTimeout;
    }
    ntStatus = NtWaitForSingleObject(hFile, FALSE, pliTimeout);
    if (NT_SUCCESS(ntStatus)) {
        return TRUE;
    }
    NaDbgPrintf(L"FileWait failed (0x%08x)!", (unsigned)ntStatus);
#else
    UNREFERENCED_PARAMETER(pliTimeout);
#endif

    ntStatus = NtWaitForSingleObject(hFile, FALSE, FALSE);

    return NT_SUCCESS(ntStatus);
}
